/* PolkitDialog.c generated by valac 0.40.11, the Vala compiler
 * generated from PolkitDialog.vala, do not modify */

/*-
 * Copyright (c) 2015-2018 elementary LLC.
 * Copyright (C) 2015-2016 Ikey Doherty <ikey@solus-project.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/*
 * Code based on budgie-desktop:
 * https://github.com/solus-project/budgie-desktop
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <polkitagent/polkitagent.h>
#include <polkit/polkit.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pwd.h>
#include <sys/types.h>
#include <grp.h>


#define AG_WIDGETS_TYPE_POLKIT_DIALOG (ag_widgets_polkit_dialog_get_type ())
#define AG_WIDGETS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog))
#define AG_WIDGETS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))
#define AG_WIDGETS_IS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_IS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AG_WIDGETS_TYPE_POLKIT_DIALOG))
#define AG_WIDGETS_POLKIT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogClass))

typedef struct _AgWidgetsPolkitDialog AgWidgetsPolkitDialog;
typedef struct _AgWidgetsPolkitDialogClass AgWidgetsPolkitDialogClass;
typedef struct _AgWidgetsPolkitDialogPrivate AgWidgetsPolkitDialogPrivate;
enum  {
	AG_WIDGETS_POLKIT_DIALOG_0_PROPERTY,
	AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* ag_widgets_polkit_dialog_properties[AG_WIDGETS_POLKIT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL,
	AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS
};
static guint ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_NUM_SIGNALS] = {0};

struct _AgWidgetsPolkitDialog {
	GtkDialog parent_instance;
	AgWidgetsPolkitDialogPrivate * priv;
	gboolean was_canceled;
};

struct _AgWidgetsPolkitDialogClass {
	GtkDialogClass parent_class;
};

struct _AgWidgetsPolkitDialogPrivate {
	PolkitAgentSession* pk_session;
	PolkitIdentity* pk_identity;
	GCancellable* cancellable;
	gulong error_signal_id;
	gulong request_signal_id;
	gulong info_signal_id;
	gulong complete_signal_id;
	GList* idents;
	gchar* cookie;
	gboolean canceling;
	GtkRevealer* feedback_revealer;
	GtkLabel* password_label;
	GtkLabel* password_feedback;
	GtkEntry* password_entry;
	GtkComboBox* idents_combo;
};


static gpointer ag_widgets_polkit_dialog_parent_class = NULL;

GType ag_widgets_polkit_dialog_get_type (void) G_GNUC_CONST;
#define AG_WIDGETS_POLKIT_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialogPrivate))
AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_new (const gchar* message,
                                                     const gchar* icon_name,
                                                     const gchar* _cookie,
                                                     GList* _idents,
                                                     GCancellable* _cancellable);
AgWidgetsPolkitDialog* ag_widgets_polkit_dialog_construct (GType object_type,
                                                           const gchar* message,
                                                           const gchar* icon_name,
                                                           const gchar* _cookie,
                                                           GList* _idents,
                                                           GCancellable* _cancellable);
static void ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                               gpointer self);
static void ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self);
static void __lambda5_ (AgWidgetsPolkitDialog* self);
static void ___lambda5__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self);
static void _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static gboolean ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                                  GdkEventKey* key);
static gboolean _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                                GdkEventKey* event,
                                                                                gpointer self);
static void _ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                        gpointer self);
static void ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_real_show (GtkWidget* base);
static void ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                                const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                                 const gchar* text,
                                                                                 gpointer self);
static void ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                       gboolean authorized);
static void _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                       gboolean gained_authorization,
                                                                                       gpointer self);
static void ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                             const gchar* request,
                                             gboolean echo_on);
static void _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                           const gchar* request,
                                                                           gboolean echo_on,
                                                                           gpointer self);
static void ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                               const gchar* text);
static void _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                               const gchar* text,
                                                                               gpointer self);
static void ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self);
static void ag_widgets_polkit_dialog_finalize (GObject * obj);


static void
_ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                          gpointer self)
{
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
}


static void
_ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self)
{
	ag_widgets_polkit_dialog_on_ident_changed ((AgWidgetsPolkitDialog*) self);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
__lambda5_ (AgWidgetsPolkitDialog* self)
{
	ag_widgets_polkit_dialog_cancel (self);
}


static void
___lambda5__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda5_ ((AgWidgetsPolkitDialog*) self);
}


static void
_ag_widgets_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
	ag_widgets_polkit_dialog_authenticate ((AgWidgetsPolkitDialog*) self);
}


static gboolean
_ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                       GdkEventKey* event,
                                                                       gpointer self)
{
	gboolean result;
	result = ag_widgets_polkit_dialog_on_key_release ((AgWidgetsPolkitDialog*) self, event);
	return result;
}


static void
_ag_widgets_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                   gpointer self)
{
	ag_widgets_polkit_dialog_cancel ((AgWidgetsPolkitDialog*) self);
}


AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_construct (GType object_type,
                                    const gchar* message,
                                    const gchar* icon_name,
                                    const gchar* _cookie,
                                    GList* _idents,
                                    GCancellable* _cancellable)
{
	AgWidgetsPolkitDialog * self = NULL;
	gchar* _tmp0_;
	GCancellable* _tmp1_;
	GtkLabel* heading = NULL;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* message_label = NULL;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkEntry* _tmp12_;
	GtkEntry* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkStyleContext* _tmp22_;
	GtkRevealer* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkLabel* _tmp25_;
	GtkComboBox* _tmp26_;
	GtkComboBox* _tmp27_;
	GtkComboBox* _tmp28_;
	GtkCellRenderer* renderer = NULL;
	GtkCellRendererPixbuf* _tmp29_;
	GtkComboBox* _tmp30_;
	GtkCellRenderer* _tmp31_;
	GtkComboBox* _tmp32_;
	GtkCellRenderer* _tmp33_;
	GtkCellRendererText* _tmp34_;
	GtkCellRenderer* _tmp35_;
	GtkComboBox* _tmp36_;
	GtkCellRenderer* _tmp37_;
	GtkComboBox* _tmp38_;
	GtkCellRenderer* _tmp39_;
	GtkComboBox* _tmp40_;
	GtkGrid* credentials_grid = NULL;
	GtkGrid* _tmp41_;
	GtkGrid* _tmp42_;
	GtkGrid* _tmp43_;
	GtkGrid* _tmp44_;
	GtkGrid* _tmp45_;
	GtkComboBox* _tmp46_;
	GtkGrid* _tmp47_;
	GtkEntry* _tmp48_;
	GtkGrid* _tmp49_;
	GtkRevealer* _tmp50_;
	GtkImage* image = NULL;
	GtkImage* _tmp51_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp52_;
	GtkOverlay* _tmp53_;
	GtkOverlay* _tmp54_;
	GtkImage* _tmp55_;
	gboolean _tmp56_ = FALSE;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp63_;
	GtkOverlay* _tmp64_;
	GtkLabel* _tmp65_;
	GtkLabel* _tmp66_;
	GtkGrid* _tmp67_;
	GtkButton* cancel_button = NULL;
	GtkWidget* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* authenticate_button = NULL;
	GtkWidget* _tmp70_;
	GtkButton* _tmp71_;
	GtkStyleContext* _tmp72_;
	GtkBox* _tmp73_;
	GtkWidget* action_area = NULL;
	GtkWidget* _tmp74_;
	GtkWidget* _tmp75_;
	g_return_val_if_fail (message != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	g_return_val_if_fail (_cookie != NULL, NULL);
	g_return_val_if_fail (_cancellable != NULL, NULL);
	self = (AgWidgetsPolkitDialog*) g_object_new (object_type, "title", _ ("Authentication Dialog"), "window-position", GTK_WIN_POS_CENTER, "resizable", FALSE, "deletable", FALSE, "skip-taskbar-hint", TRUE, NULL);
	self->priv->idents = _idents;
	_tmp0_ = g_strdup (_cookie);
	_g_free0 (self->priv->cookie);
	self->priv->cookie = _tmp0_;
	self->priv->cancellable = _cancellable;
	_tmp1_ = self->priv->cancellable;
	g_signal_connect_object (_tmp1_, "cancelled", (GCallback) _ag_widgets_polkit_dialog_cancel_g_cancellable_cancelled, self, 0);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("Authentication Required"));
	g_object_ref_sink (_tmp2_);
	heading = _tmp2_;
	_tmp3_ = heading;
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
	gtk_style_context_add_class (_tmp4_, "primary");
	_tmp5_ = heading;
	gtk_widget_set_valign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
	_tmp6_ = heading;
	gtk_label_set_xalign (_tmp6_, (gfloat) 0);
	_tmp7_ = (GtkLabel*) gtk_label_new (message);
	g_object_ref_sink (_tmp7_);
	message_label = _tmp7_;
	_tmp8_ = message_label;
	gtk_label_set_max_width_chars (_tmp8_, 60);
	_tmp9_ = message_label;
	g_object_set (_tmp9_, "wrap", TRUE, NULL);
	_tmp10_ = message_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_START);
	_tmp11_ = message_label;
	gtk_label_set_xalign (_tmp11_, (gfloat) 0);
	_tmp12_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->password_entry);
	self->priv->password_entry = _tmp12_;
	_tmp13_ = self->priv->password_entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
	_tmp14_ = self->priv->password_entry;
	g_object_set (_tmp14_, "primary-icon-name", "dialog-password-symbolic", NULL);
	_tmp15_ = self->priv->password_entry;
	g_object_set (_tmp15_, "primary-icon-tooltip-text", _ ("Password"), NULL);
	_tmp16_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->password_feedback);
	self->priv->password_feedback = _tmp16_;
	_tmp17_ = self->priv->password_feedback;
	gtk_label_set_justify (_tmp17_, GTK_JUSTIFY_RIGHT);
	_tmp18_ = self->priv->password_feedback;
	gtk_label_set_max_width_chars (_tmp18_, 40);
	_tmp19_ = self->priv->password_feedback;
	g_object_set (_tmp19_, "wrap", TRUE, NULL);
	_tmp20_ = self->priv->password_feedback;
	gtk_label_set_xalign (_tmp20_, (gfloat) 1);
	_tmp21_ = self->priv->password_feedback;
	_tmp22_ = gtk_widget_get_style_context ((GtkWidget*) _tmp21_);
	gtk_style_context_add_class (_tmp22_, GTK_STYLE_CLASS_ERROR);
	_tmp23_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp23_);
	_g_object_unref0 (self->priv->feedback_revealer);
	self->priv->feedback_revealer = _tmp23_;
	_tmp24_ = self->priv->feedback_revealer;
	_tmp25_ = self->priv->password_feedback;
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = (GtkComboBox*) gtk_combo_box_new ();
	g_object_ref_sink (_tmp26_);
	_g_object_unref0 (self->priv->idents_combo);
	self->priv->idents_combo = _tmp26_;
	_tmp27_ = self->priv->idents_combo;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp27_, TRUE);
	_tmp28_ = self->priv->idents_combo;
	g_signal_connect_object (_tmp28_, "changed", (GCallback) _ag_widgets_polkit_dialog_on_ident_changed_gtk_combo_box_changed, self, 0);
	_tmp29_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
	g_object_ref_sink (_tmp29_);
	renderer = (GtkCellRenderer*) _tmp29_;
	_tmp30_ = self->priv->idents_combo;
	_tmp31_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp30_, _tmp31_, FALSE);
	_tmp32_ = self->priv->idents_combo;
	_tmp33_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp32_, _tmp33_, "icon-name", 0);
	_tmp34_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (renderer);
	renderer = (GtkCellRenderer*) _tmp34_;
	_tmp35_ = renderer;
	g_object_set (_tmp35_, "xpad", (guint) 6, NULL);
	_tmp36_ = self->priv->idents_combo;
	_tmp37_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp36_, _tmp37_, TRUE);
	_tmp38_ = self->priv->idents_combo;
	_tmp39_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp38_, _tmp39_, "text", 1);
	_tmp40_ = self->priv->idents_combo;
	gtk_combo_box_set_id_column (_tmp40_, 1);
	_tmp41_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp41_);
	credentials_grid = _tmp41_;
	_tmp42_ = credentials_grid;
	gtk_grid_set_column_spacing (_tmp42_, 12);
	_tmp43_ = credentials_grid;
	gtk_grid_set_row_spacing (_tmp43_, 6);
	_tmp44_ = credentials_grid;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp44_, 12);
	_tmp45_ = credentials_grid;
	_tmp46_ = self->priv->idents_combo;
	gtk_grid_attach (_tmp45_, (GtkWidget*) _tmp46_, 0, 0, 1, 1);
	_tmp47_ = credentials_grid;
	_tmp48_ = self->priv->password_entry;
	gtk_grid_attach (_tmp47_, (GtkWidget*) _tmp48_, 0, 2, 1, 1);
	_tmp49_ = credentials_grid;
	_tmp50_ = self->priv->feedback_revealer;
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 0, 3, 1, 1);
	_tmp51_ = (GtkImage*) gtk_image_new_from_icon_name ("dialog-password", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	g_object_ref_sink (_tmp51_);
	image = _tmp51_;
	_tmp52_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp52_);
	overlay = _tmp52_;
	_tmp53_ = overlay;
	gtk_widget_set_valign ((GtkWidget*) _tmp53_, GTK_ALIGN_START);
	_tmp54_ = overlay;
	_tmp55_ = image;
	gtk_container_add ((GtkContainer*) _tmp54_, (GtkWidget*) _tmp55_);
	if (g_strcmp0 (icon_name, "") != 0) {
		GtkIconTheme* _tmp57_;
		_tmp57_ = gtk_icon_theme_get_default ();
		_tmp56_ = gtk_icon_theme_has_icon (_tmp57_, icon_name);
	} else {
		_tmp56_ = FALSE;
	}
	if (_tmp56_) {
		GtkImage* overlay_image = NULL;
		GtkImage* _tmp58_;
		GtkImage* _tmp59_;
		GtkImage* _tmp60_;
		GtkOverlay* _tmp61_;
		GtkImage* _tmp62_;
		_tmp58_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
		g_object_ref_sink (_tmp58_);
		overlay_image = _tmp58_;
		_tmp59_ = overlay_image;
		_tmp60_ = overlay_image;
		gtk_widget_set_valign ((GtkWidget*) _tmp60_, GTK_ALIGN_END);
		gtk_widget_set_halign ((GtkWidget*) _tmp59_, GTK_ALIGN_END);
		_tmp61_ = overlay;
		_tmp62_ = overlay_image;
		gtk_overlay_add_overlay (_tmp61_, (GtkWidget*) _tmp62_);
		_g_object_unref0 (overlay_image);
	}
	_tmp63_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp63_);
	grid = _tmp63_;
	gtk_grid_set_column_spacing (grid, 12);
	gtk_grid_set_row_spacing (grid, 6);
	gtk_widget_set_margin_right ((GtkWidget*) grid, 12);
	gtk_widget_set_margin_left ((GtkWidget*) grid, 12);
	_tmp64_ = overlay;
	gtk_grid_attach (grid, (GtkWidget*) _tmp64_, 0, 0, 1, 2);
	_tmp65_ = heading;
	gtk_grid_attach (grid, (GtkWidget*) _tmp65_, 1, 0, 1, 1);
	_tmp66_ = message_label;
	gtk_grid_attach (grid, (GtkWidget*) _tmp66_, 1, 1, 1, 1);
	_tmp67_ = credentials_grid;
	gtk_grid_attach (grid, (GtkWidget*) _tmp67_, 1, 2, 1, 1);
	_tmp68_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
	_tmp69_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, gtk_button_get_type (), GtkButton));
	cancel_button = _tmp69_;
	g_signal_connect_object (cancel_button, "clicked", (GCallback) ___lambda5__gtk_button_clicked, self, 0);
	_tmp70_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Authenticate"), (gint) GTK_RESPONSE_APPLY);
	_tmp71_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, gtk_button_get_type (), GtkButton));
	authenticate_button = _tmp71_;
	_tmp72_ = gtk_widget_get_style_context ((GtkWidget*) authenticate_button);
	gtk_style_context_add_class (_tmp72_, "suggested-action");
	g_signal_connect_object (authenticate_button, "clicked", (GCallback) _ag_widgets_polkit_dialog_authenticate_gtk_button_clicked, self, 0);
	gtk_window_set_default ((GtkWindow*) self, (GtkWidget*) authenticate_button);
	_tmp73_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	gtk_container_add ((GtkContainer*) _tmp73_, (GtkWidget*) grid);
	_tmp74_ = gtk_dialog_get_action_area ((GtkDialog*) self);
	_tmp75_ = _g_object_ref0 (_tmp74_);
	action_area = _tmp75_;
	gtk_widget_set_margin_right (action_area, 6);
	gtk_widget_set_margin_bottom (action_area, 6);
	gtk_widget_set_margin_top (action_area, 14);
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) _ag_widgets_polkit_dialog_on_key_release_gtk_widget_key_release_event, self, 0);
	g_signal_connect_object ((GtkDialog*) self, "close", (GCallback) _ag_widgets_polkit_dialog_cancel_gtk_dialog_close, self, 0);
	ag_widgets_polkit_dialog_update_idents (self);
	ag_widgets_polkit_dialog_select_session (self);
	_g_object_unref0 (action_area);
	_g_object_unref0 (authenticate_button);
	_g_object_unref0 (cancel_button);
	_g_object_unref0 (grid);
	_g_object_unref0 (overlay);
	_g_object_unref0 (image);
	_g_object_unref0 (credentials_grid);
	_g_object_unref0 (renderer);
	_g_object_unref0 (message_label);
	_g_object_unref0 (heading);
	return self;
}


AgWidgetsPolkitDialog*
ag_widgets_polkit_dialog_new (const gchar* message,
                              const gchar* icon_name,
                              const gchar* _cookie,
                              GList* _idents,
                              GCancellable* _cancellable)
{
	return ag_widgets_polkit_dialog_construct (AG_WIDGETS_TYPE_POLKIT_DIALOG, message, icon_name, _cookie, _idents, _cancellable);
}


static void
ag_widgets_polkit_dialog_real_show (GtkWidget* base)
{
	AgWidgetsPolkitDialog * self;
	GdkWindow* window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GtkEntry* _tmp4_;
	self = (AgWidgetsPolkitDialog*) base;
	GTK_WIDGET_CLASS (ag_widgets_polkit_dialog_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_dialog_get_type (), GtkDialog));
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	window = _tmp1_;
	_tmp2_ = window;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (window);
		return;
	}
	_tmp3_ = window;
	gdk_window_focus (_tmp3_, (guint32) GDK_CURRENT_TIME);
	_tmp4_ = self->priv->password_entry;
	gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
	_g_object_unref0 (window);
}


static void
ag_widgets_polkit_dialog_update_idents (AgWidgetsPolkitDialog* self)
{
	GtkListStore* model = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	gint length = 0;
	gint active = 0;
	gchar* target_user = NULL;
	GList* _tmp1_;
	GtkComboBox* _tmp36_;
	GtkListStore* _tmp37_;
	GtkComboBox* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, polkit_identity_get_type (), -1);
	model = _tmp0_;
	length = 0;
	active = 0;
	target_user = NULL;
	_tmp1_ = self->priv->idents;
	{
		GList* ident_collection = NULL;
		GList* ident_it = NULL;
		ident_collection = _tmp1_;
		for (ident_it = ident_collection; ident_it != NULL; ident_it = ident_it->next) {
			PolkitIdentity* ident = NULL;
			ident = (PolkitIdentity*) ident_it->data;
			{
				PolkitIdentity* _tmp2_;
				gchar* name = NULL;
				PolkitIdentity* _tmp3_;
				gchar* _tmp4_;
				PolkitIdentity* _tmp5_;
				GtkListStore* _tmp26_;
				GtkTreeIter _tmp27_ = {0};
				GtkListStore* _tmp28_;
				GtkTreeIter _tmp29_;
				const gchar* _tmp30_;
				PolkitIdentity* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gint _tmp35_;
				_tmp2_ = ident;
				if (_tmp2_ == NULL) {
					continue;
				}
				_tmp3_ = ident;
				_tmp4_ = polkit_identity_to_string (_tmp3_);
				name = _tmp4_;
				_tmp5_ = ident;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, polkit_unix_user_get_type ())) {
					struct passwd* pwd = NULL;
					PolkitIdentity* _tmp6_;
					struct passwd* _tmp7_;
					struct passwd* _tmp8_;
					_tmp6_ = ident;
					_tmp7_ = getpwuid ((uid_t) polkit_unix_user_get_uid (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, polkit_unix_user_get_type (), PolkitUnixUser)));
					pwd = _tmp7_;
					_tmp8_ = pwd;
					if (_tmp8_ != NULL) {
						gchar* pw_name = NULL;
						struct passwd* _tmp9_;
						const gchar* _tmp10_;
						gchar* _tmp11_;
						gboolean _tmp12_ = FALSE;
						const gchar* _tmp13_;
						const gchar* _tmp17_;
						gchar* _tmp18_;
						_tmp9_ = pwd;
						_tmp10_ = _tmp9_->pw_name;
						_tmp11_ = g_strdup (_tmp10_);
						pw_name = _tmp11_;
						_tmp13_ = target_user;
						if (_tmp13_ == NULL) {
							gint _tmp14_;
							_tmp14_ = length;
							_tmp12_ = _tmp14_ < 2;
						} else {
							_tmp12_ = FALSE;
						}
						if (_tmp12_) {
							const gchar* _tmp15_;
							gchar* _tmp16_;
							_tmp15_ = pw_name;
							_tmp16_ = g_strdup (_tmp15_);
							_g_free0 (target_user);
							target_user = _tmp16_;
						}
						_tmp17_ = pw_name;
						_tmp18_ = g_strdup (_tmp17_);
						_g_free0 (name);
						name = _tmp18_;
						_g_free0 (pw_name);
					}
				} else {
					PolkitIdentity* _tmp19_;
					_tmp19_ = ident;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp19_, polkit_unix_group_get_type ())) {
						struct group* gwd = NULL;
						PolkitIdentity* _tmp20_;
						struct group* _tmp21_;
						struct group* _tmp22_;
						_tmp20_ = ident;
						_tmp21_ = getgrgid ((gid_t) polkit_unix_group_get_gid (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, polkit_unix_group_get_type (), PolkitUnixGroup)));
						gwd = _tmp21_;
						_tmp22_ = gwd;
						if (_tmp22_ != NULL) {
							struct group* _tmp23_;
							const gchar* _tmp24_;
							gchar* _tmp25_;
							_tmp23_ = gwd;
							_tmp24_ = _tmp23_->gr_name;
							_tmp25_ = g_strdup_printf (_ ("Group: %s"), _tmp24_);
							_g_free0 (name);
							name = _tmp25_;
						}
					}
				}
				_tmp26_ = model;
				gtk_list_store_append (_tmp26_, &_tmp27_);
				iter = _tmp27_;
				_tmp28_ = model;
				_tmp29_ = iter;
				_tmp30_ = name;
				_tmp31_ = ident;
				gtk_list_store_set (_tmp28_, &_tmp29_, 0, "avatar-default-symbolic", 1, _tmp30_, 2, _tmp31_, -1);
				_tmp32_ = name;
				_tmp33_ = g_get_user_name ();
				if (g_strcmp0 (_tmp32_, _tmp33_) == 0) {
					gint _tmp34_;
					_tmp34_ = length;
					active = _tmp34_;
				}
				_tmp35_ = length;
				length = _tmp35_ + 1;
				_g_free0 (name);
			}
		}
	}
	_tmp36_ = self->priv->idents_combo;
	_tmp37_ = model;
	gtk_combo_box_set_model (_tmp36_, (GtkTreeModel*) _tmp37_);
	_tmp38_ = self->priv->idents_combo;
	_tmp39_ = active;
	gtk_combo_box_set_active (_tmp38_, _tmp39_);
	_tmp40_ = length;
	if (_tmp40_ < 2) {
		const gchar* _tmp41_;
		const gchar* _tmp42_;
		_tmp41_ = target_user;
		_tmp42_ = g_get_user_name ();
		if (g_strcmp0 (_tmp41_, _tmp42_) == 0) {
			GtkComboBox* _tmp43_;
			GtkComboBox* _tmp44_;
			_tmp43_ = self->priv->idents_combo;
			gtk_widget_set_visible ((GtkWidget*) _tmp43_, FALSE);
			_tmp44_ = self->priv->idents_combo;
			gtk_widget_set_no_show_all ((GtkWidget*) _tmp44_, TRUE);
		} else {
			GtkComboBox* _tmp45_;
			_tmp45_ = self->priv->idents_combo;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp45_, FALSE);
		}
	}
	_g_free0 (target_user);
	_g_object_unref0 (model);
}


static void
_ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                            const gchar* text,
                                                                            gpointer self)
{
	ag_widgets_polkit_dialog_on_pk_show_error ((AgWidgetsPolkitDialog*) self, text);
}


static void
_ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                                  gboolean gained_authorization,
                                                                                  gpointer self)
{
	ag_widgets_polkit_dialog_on_pk_session_completed ((AgWidgetsPolkitDialog*) self, gained_authorization);
}


static void
_ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                      const gchar* request,
                                                                      gboolean echo_on,
                                                                      gpointer self)
{
	ag_widgets_polkit_dialog_on_pk_request ((AgWidgetsPolkitDialog*) self, request, echo_on);
}


static void
_ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                          const gchar* text,
                                                                          gpointer self)
{
	ag_widgets_polkit_dialog_on_pk_show_info ((AgWidgetsPolkitDialog*) self, text);
}


static void
ag_widgets_polkit_dialog_select_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	PolkitIdentity* _tmp1_;
	const gchar* _tmp2_;
	PolkitAgentSession* _tmp3_;
	PolkitAgentSession* _tmp4_;
	gulong _tmp5_;
	PolkitAgentSession* _tmp6_;
	gulong _tmp7_;
	PolkitAgentSession* _tmp8_;
	gulong _tmp9_;
	PolkitAgentSession* _tmp10_;
	gulong _tmp11_;
	PolkitAgentSession* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pk_session;
	if (_tmp0_ != NULL) {
		ag_widgets_polkit_dialog_deselect_session (self);
	}
	_tmp1_ = self->priv->pk_identity;
	_tmp2_ = self->priv->cookie;
	_tmp3_ = polkit_agent_session_new (_tmp1_, _tmp2_);
	_g_object_unref0 (self->priv->pk_session);
	self->priv->pk_session = _tmp3_;
	_tmp4_ = self->priv->pk_session;
	_tmp5_ = g_signal_connect_object (_tmp4_, "show-error", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error, self, 0);
	self->priv->error_signal_id = _tmp5_;
	_tmp6_ = self->priv->pk_session;
	_tmp7_ = g_signal_connect_object (_tmp6_, "completed", (GCallback) _ag_widgets_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed, self, 0);
	self->priv->complete_signal_id = _tmp7_;
	_tmp8_ = self->priv->pk_session;
	_tmp9_ = g_signal_connect_object (_tmp8_, "request", (GCallback) _ag_widgets_polkit_dialog_on_pk_request_polkit_agent_session_request, self, 0);
	self->priv->request_signal_id = _tmp9_;
	_tmp10_ = self->priv->pk_session;
	_tmp11_ = g_signal_connect_object (_tmp10_, "show-info", (GCallback) _ag_widgets_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info, self, 0);
	self->priv->info_signal_id = _tmp11_;
	_tmp12_ = self->priv->pk_session;
	polkit_agent_session_initiate (_tmp12_);
}


static void
ag_widgets_polkit_dialog_deselect_session (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pk_session;
	if (_tmp0_ != NULL) {
		PolkitAgentSession* _tmp1_;
		gulong _tmp2_;
		PolkitAgentSession* _tmp3_;
		gulong _tmp4_;
		PolkitAgentSession* _tmp5_;
		gulong _tmp6_;
		PolkitAgentSession* _tmp7_;
		gulong _tmp8_;
		_tmp1_ = self->priv->pk_session;
		_tmp2_ = self->priv->error_signal_id;
		g_signal_handler_disconnect (_tmp1_, _tmp2_);
		_tmp3_ = self->priv->pk_session;
		_tmp4_ = self->priv->complete_signal_id;
		g_signal_handler_disconnect (_tmp3_, _tmp4_);
		_tmp5_ = self->priv->pk_session;
		_tmp6_ = self->priv->request_signal_id;
		g_signal_handler_disconnect (_tmp5_, _tmp6_);
		_tmp7_ = self->priv->pk_session;
		_tmp8_ = self->priv->info_signal_id;
		g_signal_handler_disconnect (_tmp7_, _tmp8_);
		_g_object_unref0 (self->priv->pk_session);
		self->priv->pk_session = NULL;
	}
}


static void
ag_widgets_polkit_dialog_authenticate (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	GtkEntry* _tmp1_;
	GtkRevealer* _tmp2_;
	PolkitAgentSession* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pk_session;
	if (_tmp0_ == NULL) {
		ag_widgets_polkit_dialog_select_session (self);
	}
	_tmp1_ = self->priv->password_entry;
	g_object_set (_tmp1_, "secondary-icon-name", "", NULL);
	_tmp2_ = self->priv->feedback_revealer;
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
	_tmp3_ = self->priv->pk_session;
	_tmp4_ = self->priv->password_entry;
	_tmp5_ = gtk_entry_get_text (_tmp4_);
	polkit_agent_session_response (_tmp3_, _tmp5_);
}


static void
ag_widgets_polkit_dialog_cancel (AgWidgetsPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->canceling = TRUE;
	_tmp0_ = self->priv->pk_session;
	if (_tmp0_ != NULL) {
		PolkitAgentSession* _tmp1_;
		_tmp1_ = self->priv->pk_session;
		polkit_agent_session_cancel (_tmp1_);
	}
	g_debug ("PolkitDialog.vala:268: Authentication cancelled");
	self->was_canceled = TRUE;
	self->priv->canceling = FALSE;
	g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
}


static void
ag_widgets_polkit_dialog_on_ident_changed (AgWidgetsPolkitDialog* self)
{
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->idents_combo;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (!_tmp2_) {
		ag_widgets_polkit_dialog_deselect_session (self);
		return;
	}
	_tmp3_ = self->priv->idents_combo;
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	model = _tmp5_;
	_tmp6_ = model;
	if (_tmp6_ == NULL) {
		_g_object_unref0 (model);
		return;
	}
	_tmp7_ = model;
	_tmp8_ = iter;
	gtk_tree_model_get (_tmp7_, &_tmp8_, 2, &self->priv->pk_identity, -1, -1);
	ag_widgets_polkit_dialog_select_session (self);
	_g_object_unref0 (model);
}


static void
ag_widgets_polkit_dialog_on_pk_session_completed (AgWidgetsPolkitDialog* self,
                                                  gboolean authorized)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
	if (!authorized) {
		_tmp0_ = TRUE;
	} else {
		GCancellable* _tmp1_;
		_tmp1_ = self->priv->cancellable;
		_tmp0_ = g_cancellable_is_cancelled (_tmp1_);
	}
	if (_tmp0_) {
		gboolean _tmp2_;
		GtkEntry* _tmp3_;
		GtkEntry* _tmp4_;
		_tmp2_ = self->priv->canceling;
		if (!_tmp2_) {
			ag_widgets_polkit_dialog_on_pk_show_error (self, _ ("Authentication failed. Please try again."));
		}
		ag_widgets_polkit_dialog_deselect_session (self);
		_tmp3_ = self->priv->password_entry;
		gtk_entry_set_text (_tmp3_, "");
		_tmp4_ = self->priv->password_entry;
		gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
		ag_widgets_polkit_dialog_select_session (self);
		return;
	} else {
		g_signal_emit (self, ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL], 0);
	}
}


static void
ag_widgets_polkit_dialog_on_pk_request (AgWidgetsPolkitDialog* self,
                                        const gchar* request,
                                        gboolean echo_on)
{
	GtkEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (request != NULL);
	_tmp0_ = self->priv->password_entry;
	gtk_entry_set_visibility (_tmp0_, echo_on);
	if (!g_str_has_prefix (request, "Password:")) {
		GtkLabel* _tmp1_;
		_tmp1_ = self->priv->password_label;
		gtk_label_set_label (_tmp1_, request);
	}
}


static void
ag_widgets_polkit_dialog_on_pk_show_error (AgWidgetsPolkitDialog* self,
                                           const gchar* text)
{
	GtkEntry* _tmp0_;
	GtkLabel* _tmp1_;
	GtkRevealer* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = self->priv->password_entry;
	g_object_set (_tmp0_, "secondary-icon-name", "dialog-error-symbolic", NULL);
	_tmp1_ = self->priv->password_feedback;
	gtk_label_set_label (_tmp1_, text);
	_tmp2_ = self->priv->feedback_revealer;
	gtk_revealer_set_reveal_child (_tmp2_, TRUE);
	ag_widgets_polkit_dialog_shake (self);
}


static void
ag_widgets_polkit_dialog_shake (AgWidgetsPolkitDialog* self)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp9_;
	gint _tmp10_;
	g_return_if_fail (self != NULL);
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	x = _tmp0_;
	y = _tmp1_;
	{
		gint n = 0;
		n = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_;
				gint diff = 0;
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = n;
					n = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = n;
				if (!(_tmp4_ < 10)) {
					break;
				}
				diff = 15;
				_tmp5_ = n;
				if ((_tmp5_ % 2) == 0) {
					diff = -15;
				}
				_tmp6_ = x;
				_tmp7_ = diff;
				_tmp8_ = y;
				gtk_window_move ((GtkWindow*) self, _tmp6_ + _tmp7_, _tmp8_);
				while (TRUE) {
					if (!gtk_events_pending ()) {
						break;
					}
					gtk_main_iteration ();
				}
				g_usleep ((gulong) 10000);
			}
		}
	}
	_tmp9_ = x;
	_tmp10_ = y;
	gtk_window_move ((GtkWindow*) self, _tmp9_, _tmp10_);
}


static void
ag_widgets_polkit_dialog_on_pk_show_info (AgWidgetsPolkitDialog* self,
                                          const gchar* text)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	g_info ("PolkitDialog.vala:347: %s", text);
}


static gboolean
ag_widgets_polkit_dialog_on_key_release (AgWidgetsPolkitDialog* self,
                                         GdkEventKey* key)
{
	gboolean result = FALSE;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (key != NULL, FALSE);
	_tmp0_ = key->keyval;
	switch (_tmp0_) {
		case GDK_KEY_KP_Enter:
		case GDK_KEY_Return:
		{
			ag_widgets_polkit_dialog_authenticate (self);
			result = GDK_EVENT_STOP;
			return result;
		}
		default:
		break;
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}


static void
ag_widgets_polkit_dialog_class_init (AgWidgetsPolkitDialogClass * klass)
{
	ag_widgets_polkit_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AgWidgetsPolkitDialogPrivate));
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget *)) ag_widgets_polkit_dialog_real_show;
	G_OBJECT_CLASS (klass)->finalize = ag_widgets_polkit_dialog_finalize;
	ag_widgets_polkit_dialog_signals[AG_WIDGETS_POLKIT_DIALOG_DONE_SIGNAL] = g_signal_new ("done", AG_WIDGETS_TYPE_POLKIT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
ag_widgets_polkit_dialog_instance_init (AgWidgetsPolkitDialog * self)
{
	self->priv = AG_WIDGETS_POLKIT_DIALOG_GET_PRIVATE (self);
	self->was_canceled = FALSE;
	self->priv->pk_session = NULL;
	self->priv->pk_identity = NULL;
	self->priv->canceling = FALSE;
}


static void
ag_widgets_polkit_dialog_finalize (GObject * obj)
{
	AgWidgetsPolkitDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AG_WIDGETS_TYPE_POLKIT_DIALOG, AgWidgetsPolkitDialog);
	_g_object_unref0 (self->priv->pk_session);
	_g_object_unref0 (self->priv->pk_identity);
	_g_free0 (self->priv->cookie);
	_g_object_unref0 (self->priv->feedback_revealer);
	_g_object_unref0 (self->priv->password_label);
	_g_object_unref0 (self->priv->password_feedback);
	_g_object_unref0 (self->priv->password_entry);
	_g_object_unref0 (self->priv->idents_combo);
	G_OBJECT_CLASS (ag_widgets_polkit_dialog_parent_class)->finalize (obj);
}


GType
ag_widgets_polkit_dialog_get_type (void)
{
	static volatile gsize ag_widgets_polkit_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&ag_widgets_polkit_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AgWidgetsPolkitDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ag_widgets_polkit_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AgWidgetsPolkitDialog), 0, (GInstanceInitFunc) ag_widgets_polkit_dialog_instance_init, NULL };
		GType ag_widgets_polkit_dialog_type_id;
		ag_widgets_polkit_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "AgWidgetsPolkitDialog", &g_define_type_info, 0);
		g_once_init_leave (&ag_widgets_polkit_dialog_type_id__volatile, ag_widgets_polkit_dialog_type_id);
	}
	return ag_widgets_polkit_dialog_type_id__volatile;
}



